/*
 * at91lib_spi.c
 *
 *  Created on: 01.02.2010
 *      Author: Pernicius
 */

#include "at91lib_spi.h"


#ifndef SPI_SCKDIV
#	define SPI_SCKDIV	4
#endif


//............................................................................
void at91_spi_init(void) {
	// enable clock to SPI interface
	AT91C_BASE_PMC->PMC_PCER = (1<<AT91C_ID_SPI);

	// setup PIO pins for SPI bus
	AT91C_BASE_PIOA->PIO_ASR   = /*AT91C_PA12_MISO |*/ AT91C_PA13_MOSI | AT91C_PA14_SPCK;    // assign pins to SPI interface
	AT91C_BASE_PIOA->PIO_PDR   = /*AT91C_PA12_MISO |*/ AT91C_PA13_MOSI | AT91C_PA14_SPCK;
	AT91C_BASE_PIOA->PIO_PPUER = /*AT91C_PA12_MISO |*/ AT91C_PA13_MOSI | AT91C_PA14_SPCK;    // set pullups

	// setup PIO pins for SPI chip selects
	//AT91C_BASE_PIOA->PIO_ASR = AT91C_PA11_NPCS0 | AT91C_PA31_NPCS1;
	//AT91C_BASE_PIOA->PIO_PDR = AT91C_PA11_NPCS0 | AT91C_PA31_NPCS1;
	//AT91C_BASE_PIOA->PIO_OER = AT91C_PA11_NPCS0 | AT91C_PA31_NPCS1;
// config pin
AT91C_BASE_PIOA->PIO_PER = AT91C_PA31_NPCS1;
AT91C_BASE_PIOA->PIO_OER = AT91C_PA31_NPCS1;
AT91C_BASE_PIOA->PIO_PER = (1<<22);
AT91C_BASE_PIOA->PIO_OER = (1<<22);

	// reset and enable SPI
	AT91C_BASE_SPI->SPI_CR = AT91C_SPI_SPIEN | AT91C_SPI_SWRST;
	AT91C_BASE_SPI->SPI_CR = AT91C_SPI_SPIEN;

	// set master mode with:
	//  - SPI master
	//  - no mode fault
	//  - variable peripheral chip select
	AT91C_BASE_SPI->SPI_MR = AT91C_SPI_MSTR | AT91C_SPI_MODFDIS | AT91C_SPI_PS_VARIABLE;

	// setup data transfer format and rate for device 0-3 => 8bits, CPOL=0, NCPHA=1
	AT91C_BASE_SPI->SPI_CSR[0] = AT91C_SPI_NCPHA | AT91C_SPI_BITS_8 | (SPI_SCKDIV<<8);
	AT91C_BASE_SPI->SPI_CSR[1] = AT91C_SPI_NCPHA | AT91C_SPI_BITS_8 | (SPI_SCKDIV<<8);
	AT91C_BASE_SPI->SPI_CSR[2] = AT91C_SPI_NCPHA | AT91C_SPI_BITS_8 | (SPI_SCKDIV<<8);
	AT91C_BASE_SPI->SPI_CSR[3] = AT91C_SPI_NCPHA | AT91C_SPI_BITS_8 | (SPI_SCKDIV<<8);
}
//............................................................................
void at91_spi_chipselect(uint8_t device) {
	// 31 - NPCS1
	if(device == SPI_CS_OFF) {
		// clear SPI_CS pin
		AT91C_BASE_PIOA->PIO_SODR = (1<<31);
	}
	else {
		// set SPI_A0..SPI_A2 pins
// TODO: at91_spi_chipselect
		// set SPI_CS pin
		AT91C_BASE_PIOA->PIO_CODR = (1<<31);
	}
}
//............................................................................
void at91_spi_sendbyte(uint16_t data) {
	// wait for transmit completion/ready
	while(!(AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE));
	// write data to be transmitted
	AT91C_BASE_SPI->SPI_TDR = data;
	// wait for completion
	while(!(AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF));
}
//............................................................................
void at91_spi_config(uint8_t device, uint32_t flags) {
	// TODO: at91_spi_config
}
