/*
 * dogm128_gfx.c
 *
 *  Created on: 28.02.2010
 *      Author: Pernicius
 */

#include "dogm128.h"


// config
#define DISP_WIDTH		128
#define DISP_HEIGHT		64

// local defines
#define DISP_PAGES		(DISP_HEIGHT/8)
#define DISP_COLLS		DISP_WIDTH


// internal vars
extern uint8_t volatile _dogm128_dispbuffer[DISP_PAGES*DISP_COLLS];
extern uint8_t volatile _dogm128_pagechange;


//............................................................................
void dogm128_setpixel(uint16_t x, uint16_t y) {
	if (x < DISP_WIDTH && y < DISP_HEIGHT) {
		_dogm128_dispbuffer[(y >> 3) + (x << 3)] |=  (1 << (y & 0x07));
	}
	_dogm128_pagechange |= (1 << (y >> 3));
}
//............................................................................
void dogm128_clearpixel(uint16_t x, uint16_t y) {
	if (x < DISP_WIDTH && y < DISP_HEIGHT) {
		_dogm128_dispbuffer[(y >> 3) + (x << 3)] &= ~(1 << (y & 0x07));
	}
	_dogm128_pagechange |= (1 << (y >> 3));
}
//............................................................................
void dogm128_rect(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint32_t flags) {
	// TODO: dogm128_rect
}
//............................................................................
void dogm128_circle(uint16_t x, uint16_t y, uint16_t r, uint32_t flags) {
	// TODO: dogm128_circle
}
