//****************************************************************************
//	File Name    : 'isr.h'
//	Title        : interface to the ISRs
//	Author       : Lennart Schmidt - Copyright (C) 2010
//	Created      : 2010.01.26
//	Revised      :
//	Version      : 0.1
//	Target MCU   : Atmel ARM AT91SAM7S Series
//	Editor Tabs  : 4
//
//	NOTE: This code is currently below version 1.0, and therefore is
//		considered to be lacking in some functionality and/or documentation,
//		or may not be fully tested.
//		Nonetheless, you can expect most functions to work.
//
//****************************************************************************
//	This code is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 2 of the License, or
//	(at your option) any later version.
//
//	This code is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this code. If not, see <http://www.gnu.org/licenses/>.
//****************************************************************************


#ifndef ISR_H_
#define ISR_H_


// Exact-width integer types. WG14/N843 C99 Standard
#include <stdint.h>


enum EventFlags {
    PIT_FLAG,
    TIMER0_FLAG,
    TIMER1_FLAG,
    // . . .
};


//****************************************************************************
//	Function Prototypes
//****************************************************************************

// ISR events
void eventFlagSet(uint8_t flag);
uint8_t eventFlagCheck(uint8_t flag);

// IRQ/FRQ
void ISR_irq(void);
void ISR_fiq(void);
// System ISRs
void ISR_spur(void);
void ISR_abort(char const *msg);
// ISRs
void ISR_pit(void);
void ISR_timer0(void);


#endif // ISR_H_
