/*
 * syscalls.c
 *
 *  Created on: 03.02.2010
 *      Author: Pernicius
 */


#include <stdlib.h>
#include <reent.h>
#include <sys/stat.h>
#include "at91lib_uart.h"


#define PUTC_FUNC	at91_uart0_putc
#define GETC_FUNC	at91_uart0_getc
//#define RXWAIT_FUNC	at91_uart0_putc


/**** Locally used variables. ****/

// end is set in the linker command file and is the end of
// statically allocated data (thus start of heap).
extern char end[];

// Points to current end of the heap.
static char *heap_ptr;


//............................................................................
_ssize_t _read_r(struct _reent *r, int file, void *ptr, size_t len) {
	char c;
	int  i;
	unsigned char *p;

	p = (unsigned char*)ptr;

	for (i = 0; i < len; i++) {
//		while ( !uart0_kbhit() ) ;
		c = (char) GETC_FUNC();
		if (c == 0x0D) {
			*p='\0';
			break;
		}
		*p++ = c;
		PUTC_FUNC(c);
	}
	return len - i;
}
//............................................................................
_ssize_t _write_r(struct _reent *r, int file, const void *ptr, size_t len) {
	int i;
	const unsigned char *p;

	p = (const unsigned char*) ptr;

	for (i = 0; i < len; i++) {
		if (*p == '\n' ) PUTC_FUNC('\r');
		PUTC_FUNC(*p++);
	}
	return len;
}
//............................................................................
int _close_r(struct _reent *r, int file) {
	return 0;
}
//............................................................................
_off_t _lseek_r(struct _reent *r, int file, _off_t ptr, int dir) {
	return (_off_t)0;	// Always indicate we are at file beginning.
}
//............................................................................
int _fstat_r(struct _reent *r, int file, struct stat *st) {
	// Always set as character device.
	st->st_mode = S_IFCHR;
	// assigned to strong type with implicit signed/unsigned conversion.
	// Required by newlib.

	return 0;
}
//............................................................................
int _isatty(int file);
int _isatty(int file) {
	return 1;
}


/*****************************************************************************
 *	Support function. Adjusts end of heap to provide more memory to
 *	memory allocator. Simple and dumb with no sanity checks.
 *
 *	struct _reent *r -- re-entrancy structure, used by newlib to
 *	                    support multiple threads of operation.
 *	ptrdiff_t nbytes -- number of bytes to add.
 *	                    Returns pointer to start of new heap area.
 *
 *	Note:  This implementation is not thread safe (despite taking a
 *	       _reent structure as a parameter).
 *	       Since _s_r is not used in the current implementation,
 *	       the following messages must be suppressed.
 ****************************************************************************/
void * _sbrk_r(struct _reent *_s_r, ptrdiff_t nbytes) {
	char  *base;		//  errno should be set to  ENOMEM on error

	if (!heap_ptr) {	//  Initialize if first time through.
		heap_ptr = end;
	}
	base = heap_ptr;	//  Point to end of heap.
	heap_ptr += nbytes;	//  Increase heap.

	return base;		//  Return pointer to start of new heap area.
}
